-- ----------------------------------------------
-- DROP STATEMENTS
-- ----------------------------------------------

--DROP TABLE CIB_IDS;
--DROP TABLE CIB_PARAMETER;
--DROP TABLE CIB_CONTROLLEDOBJECT;
--DROP TABLE CIB_ARCHIVE;
--DROP TABLE CIB_INTEGRITYCHECKRESULT;
--DROP TABLE CIB_INTEGRITYCHECK;

-- ----------------------------------------------
-- TABLES FOR PRODUCTION
-- ----------------------------------------------

CREATE TABLE CIB_CONTROLLEDOBJECT (
	OBJECT_TYPE VARCHAR(50) NOT NULL, 
	CONTROLLEDOBJECTID BIGINT NOT NULL,
	CASEID VARCHAR(60),
	CONTROLACTION VARCHAR(50) NOT NULL, 
   CONTROLACTION VARCHAR(50) NOT NULL, 
	OBJECTCLASS VARCHAR(255), 
	EDITUSERID VARCHAR(50), 
	EDITDATE TIMESTAMP, 
	FIRSTAPPROVALUSERID VARCHAR(50), 
	FIRSTAPPROVALDATE TIMESTAMP, 
	OWNER VARCHAR(255), 
	METHODNAME VARCHAR(100), 
	OBJECTID VARCHAR(255), 
	BYTEOBJECT BLOB(64 K), 
	FACTORYCLASS VARCHAR(255),
	primary key(CONTROLLEDOBJECTID)
);

CREATE TABLE CIB_ARCHIVE (
	ARCHIVEID BIGINT NOT NULL, 
	CASEID VARCHAR(60),
	CONTROLEVENT VARCHAR(50), 
	CREATEUSERID VARCHAR(50), 
	CREATEDATE TIMESTAMP, 
	OBJECTID VARCHAR(50), 
	OBJECTCLASS VARCHAR(255), 
	BYTEOBJECT BLOB(64 K), 
	METHODNAME VARCHAR(100), 
	OWNER VARCHAR(255), 
	REMARK VARCHAR(255),
	FACTORYCLASS VARCHAR(255),
	RESULT BLOB(64 K),
	ARCHIVE_TYPE VARCHAR(30),
	CHECKSUM VARCHAR(255),
	LASTARCHIVEID BIGINT,
	primary key(ARCHIVEID)
);

CREATE TABLE CIB_PARAMETER (
	PARAMETERID				BIGINT NOT NULL, 
	ARCHIVE_ARCHIVEID		BIGINT, 
	CONTROLLEDOBJECT_CONTROLLEDOBJECTID		BIGINT, 
	VALUE					BLOB(64 K), 
	VALUETYPE				VARCHAR(255) NOT NULL,
	PARAM_TYPE				VARCHAR(30) NOT NULL,
	PRIMARY KEY(PARAMETERID)
);	

CREATE TABLE CIB_IDS (GEN_KEY VARCHAR(255), GEN_VALUE INTEGER);

CREATE TABLE CIB_INTEGRITYCHECK (
	INTEGRITYCHECKID	BIGINT NOT NULL,
	CHECKDATE			TIMESTAMP,
	CHECKSTATUS			VARCHAR(50),
	ADDEDRECORDS		BIGINT,
	MISSINGRECORDS		BIGINT,
	MODIFIEDRECORDS		BIGINT,
	TOTALRECORDS		BIGINT,
	PRIMARY KEY(INTEGRITYCHECKID)
);

CREATE TABLE CIB_INTEGRITYCHECKRESULT (
	INTEGRITYCHECKRESULTID	BIGINT NOT NULL,
	ARCHIVEID				BIGINT, 
	RESULT					VARCHAR(50),
	INTEGRITYCHECK_INTEGRITYCHECKID  BIGINT, 
	PRIMARY KEY(INTEGRITYCHECKRESULTID)
);

-- ----------------------------------------------
-- INSERT STATEMENTS
-- ----------------------------------------------

INSERT INTO CIB_ARCHIVE (ARCHIVEID,	CONTROLEVENT, CREATEUSERID, 
	CREATEDATE,	OWNER, REMARK, ARCHIVE_TYPE, CHECKSUM, LASTARCHIVEID)
	VALUES (
	-1, 'UNKNOWN', 'SYSTEM INITIALISATION', null, 
	'CIBET-INTERNAL',
	'this entry controls the checksum of the last Archive entry',
	'DataModificationArchive', 
	'978addad2338c2a7085d5d620412190de703e93fe1c28ac9dd31d18a667451f6', 
	-1
);

